<h4>Formularios <small>Data</small></h4>
<hr>
<form [formGroup]="forma" (ngSubmit)="guardarCambios()">

  <div formGroupName="nombreCompleto">
    <div class="form-group row" [ngClass]="{'has-danger': !forma.get('nombreCompleto.nombre').valid}">
      <label class="col-2 col-form-label">Nombre</label>
      <div class="col-8">

        <input class="form-control"
               type="text"
               placeholder="Nombre"
               formControlName="nombre">
        <div
            *ngIf="forma.get('nombreCompleto.nombre').errors?.required"
            class="form-control-feedback">
          Este campo es requerido.
        </div>
        <div
            *ngIf="forma.get('nombreCompleto.nombre').errors?.minlength"
            class="form-control-feedback">
          Este campo debe tener por lo menos 
          {{ forma.get('nombreCompleto.nombre').errors.minlength.requiredLength }} caracteres, pero 
          tiene {{ forma.get('nombreCompleto.nombre').errors.minlength.actualLength }} caracteres actualmente.
        </div>
      </div>
    </div>

    <div class="form-group row">
      <label class="col-2 col-form-label">Apellido</label>
      <div class="col-8">

        <input class="form-control"
               type="text"
               placeholder="Apellido"
               formControlName="apellido">
      </div>
    </div>

  </div>

  <div class="form-group row">
    <label class="col-2 col-form-label">Correo</label>
    <div class="col-md-8">

      <input class="form-control"
             type="email"
             placeholder="Correo electrónico"
             formControlName="email">
    </div>
  </div>

  <div class="form-group row">
    <label class="col-2 col-form-label">Nombre de Usuario</label>
    <div class="col-md-8">

      <input class="form-control"
             type="text"
             placeholder="User Name"
             formControlName="userName">
    </div>
  </div>

  <div class="form-group row">
    <label class="col-2 col-form-label">Password</label>
    <div class="col-md-8">

      <input class="form-control"
             type="password"
             placeholder="Password"
             formControlName="password1">
    </div>
  </div>

  <div class="form-group row">
    <label class="col-2 col-form-label">Confirmar Password</label>
    <div class="col-md-8">

      <input class="form-control"
             type="password"
             placeholder="Repetir Password"
             formControlName="password2">
    </div>
  </div>

  <div class="form-group row">
    <label class="col-2 col-form-label">Pasatiempos</label>
    <div class="col-md-8" formArrayName="pasatiempos">
      <input
          *ngFor="let pasatiempo of forma.controls['pasatiempos'].controls; let i = index"
          [formControlName]="i"
          type="text"
          class="form-control" >
    </div>
    <button
        (click)="agregarPasatiempo()"
        type="button" class="btn btn-primary">
      Nuevo
    </button>
  </div>



  <div class="form-group row">
    <label class="col-2 col-form-label">&nbsp;</label>
    <div class="input-group col-md-8">
      <button type="submit" class="btn btn-outline-primary">
        Guardar
      </button>
    </div>
  </div>

  Valido: {{ forma.valid }}<br>
  Estatus: {{ forma.status }}

</form>

<pre>
  {{ forma.value | json }}
</pre>